#ifndef FAST_MUL_H_INCLUDED
#define FAST_MUL_H_INCLUDED
#include "types.h"



class FAST_MUL_STAGE
{
FAST_MUL_STAGE *low_stage;
u32 len;

// temporary data 

u32 *z0;  // size = size 
u32 *z1;  // size = size + size/2  
u32 *z2;  // size = size 
u32 *xx;  // size = 1 + size/2
u32 *yy;  // size = 1 + size/2
 
public:
    FAST_MUL_STAGE(FAST_MUL_STAGE *lower_stage, u32 size_x32);
    ~FAST_MUL_STAGE();
    void fast_mul(u32 *result, u32 const  *x, u32 const  *y);
    void reset();
   
};

//------------------------
// Note: the length of operands must be power of 2
//
class FAST_MUL
{
u32 len; // len of the operands in 32-bit words
u32 number_of_stages; 

FAST_MUL_STAGE **fast_mul_stage;


public:
    FAST_MUL(u32 size_x32);
    ~FAST_MUL();
    void reset(); // flush all intermediate results
    void fast_mul(u32 *result, u32 const  *x, u32 const  *y); // Note: operands should not overlap with result!


};

//-----------------------------


u64 karatsuba_test(u32 x, u32 y);


#endif

