#ifndef IDEA_H_INCLUDED
#define IDEA_H_INCLUDED
#include "types.h"
#include <stdio.h>
//
// Encrypt/decrypt data[2] using key[4]
//
void IDEA_Encode(u32 *x, u32 const *key, u32 number_of_blocks = 1);
void IDEA_Decode(u32 *x, u32 const *key, u32 number_of_blocks = 1);

// Define this to pass test vectors on PC
// (it has to do with endianess)
//
#define IDEA_PC_COMPATIBILITY  

// Optional enforcement against weak keys
// If you enable this, standard test vector set won't pass
//#define IDEA_ENFORCE_AGAINST_WEAK_KEYS

static const u32 IDEA_NUMBER_OF_SUBKEYS = 52;
static const u32 IDEA_ROUNDS = 8;


class IDEA
 {
 u32 encryption_subkeys[IDEA_NUMBER_OF_SUBKEYS];
 u32 decryption_subkeys[IDEA_NUMBER_OF_SUBKEYS];

 public:
    IDEA(u32 const *key = NULL);
    void SetKey(u32 const *key);
    void Encode(u32 *x, u32 const *key);
    void Decode(u32 *x, u32 const *key);
    void Encode(u32 *x);
    void Decode(u32 *x);
    
    void reset(void);
    
 };

int IDEA_Selftest(void);

//----------------
// Run IDEA with same key over several blocks
//

#endif

