#ifndef PKF_H_INCLUDED
#define PKF_H_INCLUDED

#include "types.h"

static const u32 pkf_default_mem_size_x32 = 262144;    // 1M bytes
static const u32 pkf_max_mem_size_x32     = 268435456; // 1G bytes
static const u32 pkf_min_mem_size_x32     = 4;         // 16 bytes
static const u32 pkf_default_rounds       = 4;
static const u32 pkf_min_passes           = 4;

class PKF
 {
 u32 *mem;
 u32  mem_size_x32;
 u32  mem_idx_mask;
 u32  rounds;
 u64 state[3];


public:
 
 PKF(u32 mem_size_x32 = pkf_default_mem_size_x32, u32 rounds = pkf_default_rounds); // mem_size in 32 bit words, should be a power of 2
 ~PKF();
 void reset();
 void get_key(void *key,const u32 key_size_bytes, 
              void const *salt, const u32 salt_size_bytes,  // should not be NULL, 0
              void const *passwd, const u32 passwd_size_bytes); // should not be NULL, 0
 };


int pkf_test(); // returns 1 if OK

#endif

