#ifndef RANDOM_H_INCLUDED
#define RANDOM_H_INCLUDED

#include "types.h"
#include <stdio.h>
#include <tchar.h>

// Generate strong pseudorandom numbers


void random_number(u32 *x, const u32 length_x32);


//----------------------------------
// Collect entropy into main seed
//
void collect_entropy(); // system provided
void collect_entropy(u32 const* data); // data u32[2] for legacy compatibility
void collect_entropy(void const * data, const u32 data_size_bytes);


void reset_stack(void);

u32 cheap_random_number();
void cheap_random_number(u32 *x, const u32 length_x32);
void cheap_random_number(u8 *x, const u32 size_of_x_bytes);


#ifndef _UNICODE

void initialize_seed(const char *path = NULL); // Initialize main seed file

#else

void initialize_seed(const TCHAR *path = NULL); // Initialize main seed file

#endif

#endif

