#ifndef SC128_H_INCLUDED
#define SC128_H_INCLUDED

#include "types.h"

static const u32 default_max_size_blocks = 32; // 32 x 128 = 4096 bit ~ 3M of tables

class SC128_PRECALCULATED_KEYS
 {
 u32 sc128_precalculated_size;
 u64 *keys;

public:
    SC128_PRECALCULATED_KEYS(u32 max_size_x128 = default_max_size_blocks);
    ~SC128_PRECALCULATED_KEYS();
    u64 const* precalculated_keys();
    u32 max_precalculated_size_x128();
 };

class SC128_CIPHER
 {
 u32 len_128; // length in 128 blocks
 u32 N_rounds;
 u32 feistel_key_len_64;
 u64 const* feistel_key;

 SC128_PRECALCULATED_KEYS *local_precalculated_keys;

public:
    SC128_CIPHER(u32 width_128); // width128 = data width in 128 bit blocks; key width = 2 x data width
    ~SC128_CIPHER();
    void Encode(u64 *data, u64 const *key);
    void Decode(u64 *data, u64 const *key);
    void Reset();
 };


#endif

