#ifndef PASSWORD_H_INCLUDED
#define PASSWORD_H_INCLUDED
//-----------------------------------------------------------------------
#include "types.h"
#include "cp_strop.h"
//----------------------------------------------------------------------------
static const u32 password_max_length = 128;
//-----------------------------------------------------------------------
u32 PasswordRequest(HWND hWnd, u8* password, int* remember);
BOOL GenerateKey(HWND hWnd, LPTSTR keyFileName);
u32 ChangePassword(HWND hWnd, LPTSTR keyFileName, u8* new_password);
bool LoadKey(HWND hWnd, LPTSTR fileName, SECRET_DATA *data);
void add_to_entropy(u32 a, u32 b);
//-----------------------------------------------------------------------
bool save_file_signature(pctstr_t filename);
bool verify_file_signature(pctstr_t filename);
//-----------------------------------------------------------------------
int read_string_from_file(FILE* F, ptstr_t* str, u32* str_size, XEX_ENCRYPT_DECRYPT* xex, u64* xex_num);
void write_string_to_file(FILE* F, pctstr_t str, XEX_ENCRYPT_DECRYPT* xex, u64* xex_num);
void write_data_to_file(FILE* F, const void* str, size_t size, XEX_ENCRYPT_DECRYPT* xex, u64* xex_num);
//-----------------------------------------------------------------------
// xml_writer implementation for secret FILE*
class PUGIXML_CLASS xml_writer_secret_file: public xml_writer
{
public:
	// Construct writer from a FILE* object; void* is used to avoid header dependencies on stdio
	xml_writer_secret_file(void* file, XEX_ENCRYPT_DECRYPT* xex, u64* xex_num);

	void write(const void* data, size_t size);

private:
	XEX_ENCRYPT_DECRYPT* xex;
	void* file;
	u64* xex_num;
};
//-----------------------------------------------------------------------
#endif //PASSWORD_H_INCLUDED
