#ifndef SETTINGS_H_INCLUDED
#define SETTINGS_H_INCLUDED
//-----------------------------------------------------------------------
#include <Mmsystem.h>
#include "types.h"
#include "signature.h"
#include "log.h"
#include "kademlia.h"
//-----------------------------------------------------------------------
typedef struct {
	TCHAR keyFileName[MAX_PATH];
	TCHAR userFileName[MAX_PATH];
	TCHAR logFileName[MAX_PATH];
	TCHAR likesFileName[MAX_PATH];
	TCHAR ftPath[MAX_PATH];
	TCHAR downloadsFileName[MAX_PATH];
	TCHAR seedFileName[MAX_PATH];
	int mic_agc;
	int audio_quality;
	int video_quality;
	int video_resolution;
	TCHAR microphone[MAXPNAMELEN];
	TCHAR speaker[MAXPNAMELEN];
	TCHAR video[64];
	int rememberPassword;
	u32 passwordTime;
	u16 localPort;
	u16 remotePort;
	int enableUPnP;
	int removeUPnPonExit;
	int nextAvailablePort;
	int randomPort;
	int encapsulation;
	int enableLogFile;
	int reciveFiles;
	int allowAnyone;
	int allowConnection;
	int acceptFT;
	int autostart;
	int preventsleep;
	int openfirewall;
	int showSplash;
	int checkNewVersion;
	int obfuscationEnabled;
	int showSessionDebug;
	int replaceLocalIP;
	UINT volume;
	UINT ring_volume;
	UINT mic;
	UINT woNum;
	UINT away_timeout;
	UINT log_size;
	TCHAR chatFontName[200];
	bool continue_rec; // for selftest dialog
} settings_t;
//-----------------------------------------------------------------------
void SettingDialog(HWND hWnd, settings_t* set, USERS* usr, KADEMLIA* kad);
void LoadSettings(HWND hWnd, settings_t* set);
void SaveSettings(HWND hWnd, settings_t* set);
void LoadNodes(HWND hWnd, LPTSTR fileName, NODE **nds, u32* size);

void SelectFile(HWND hWnd, UINT idc);
VOID URL2IP(LPCTSTR url, u32* ip);
void CheckNewVersion(HWND hWnd, bool show_same = false);
void getModuleDirectory(LPTSTR dir);
//-----------------------------------------------------------------------
bool GetSaveChat(const u32* id);
void SetSaveChat(const u32* id,bool save);
VOID SaveWindowPosition(LPTSTR name, WINDOWPLACEMENT* pos);
VOID LoadWindowPosition(LPTSTR name, WINDOWPLACEMENT* pos);
//-----------------------------------------------------------------------
#endif //SETTINGS_H_INCLUDED
